from netCDF4 import Dataset
import numpy as np
import math

def gcd(a,b):
    # greatest common divisor of (a,b) (had to write it myself because math.gcd isn't working?
    def getfactors(n):
        factorsn = []
        for i in range(1,n+1):
            if n%i==0:
                factorsn.append(i)
        return factorsn
    factsa=getfactors(a)
    factsb=getfactors(b)
    commons=[]
    for i in factsa:
        if i in factsb:
            commons.append(i)
    return max(commons)

# takes the variable 'day' from the old netcdf and makes a new array with regular spacing
#fname='Mprof_6901486_L75_from_A18_5days_2015-01-01_2015-12-31'
fname='Mprof_6901527_L75_from_A18_5days_2014-01-01_2014-12-31'
old=Dataset(fname + '.nc')
daysold = np.array(old.variables['doy'])
daysolddiffs=daysold[1:]-daysold[:-1]
daysolddiffs=np.unique(daysolddiffs)
lcm=daysolddiffs[0]
for i in daysolddiffs[1:]:
    lcm=gcd(lcm,i)
start=daysold[0]%lcm
daysnew=np.concatenate((np.arange(start,daysold[-1],lcm),[daysold[-1]]))

# initialise new netcdf and set the length of days new as a dimension
new = Dataset(fname + 'reg.nc','w', format='NETCDF4')
time = new.createDimension("time", np.shape(daysnew)[0])

# create a mask length daynew. 1 if the data for the day exists, 0 if not
mask=np.zeros_like(daysnew)
for i in range(len(mask)):
    if daysnew[i] in daysold:
        mask[i]=1

# add the other dimensions to the new netcdf
for i in old.dimensions:
    if i!='time':
        new.createDimension(i, len(old.dimensions[i]))

# writing the variables onto the netcdf
for i in old.variables:

    T = np.array(old[i]).dtype
    newdims = []
    for j in old[i].dimensions:
        newdims.append(j)
    new.createVariable(i, T, newdims)
    if T=='int32':
        new[i][:]=99999
    else:
        new[i][:]=np.nan
    if 'time' in old[i].dimensions:
        new[i][mask==1]=np.array(old.variables[i])
    else:
        # if time not a dimension, copy entire variable as is
        new[i][:]=np.array(old.variables[i])

# ensure that the new days are the same
new['doy'][:]=daysnew
